/***************************************************************************/
/* The 2nd ARC/CPSY/RECONF High-Performance Computer System Design Contest */
/* 310_sort Version 2014-06-06                                             */
/***************************************************************************/

#include "../../lib/lib.c"
/**********************************************************************/
#ifdef __ALTERA__
volatile int *init_data = (int*)0x0c000000;
volatile int *init_n    = (int*)0x0c03fffc;
#define DATA_START 0x0c090000
#else
volatile int *init_data = (int*)0x00040000;
volatile int *init_n    = (int*)0x0007fffc;
#define DATA_START 0x90000
#endif

/**********************************************************************/
void qsort(int data[], int left, int right)
{
    int temp = 0;
    int i = left + 1;
    int k = right;
    while (i < k) {
        while (data[i] < data[left] && i < right) i++;
        while (data[k] >= data[left] && k > left) k--;
        if (i < k) {
            temp = data[i];
            data[i] = data[k];
            data[k] = temp;
        }
    }
    if (right-left != 1 || data[left] > data[k]) {
        temp = data[left];
        data[left] = data[k];
        data[k] = temp;
    }
    if (left < k-1)  qsort(data, left, k-1);
    if (k+1 < right) qsort(data, k+1, right);
}

/**********************************************************************/
int main(void) {
    int i;
    int n = *init_n;

    mylib_display_char('s');
    mylib_display_char('o');
    mylib_display_char('r');
    mylib_display_char('t');
    mylib_display_char(' ');
    mylib_display_char('n');
    mylib_display_char('=');
    mylib_display_dec(n);
    mylib_display_newline();
    mylib_display_newline();
    
    int *data = (int*) DATA_START;

    /* ----- Initialize ----- */ 
    for (i=0; i<n; i++) data[i] = init_data[i % (64*1024)] + i;

    for (i = 0; i < 100; i++) {
        mylib_display_dec(data[i]);
        mylib_display_char(' ');
    }
    mylib_display_newline();
    
    /* -----  main kernel ----- */ 
    qsort(data, 0, n-1);
    
    /* -----  show result ----- */
    mylib_display_newline();
    for (i = 0; i < n; i=i+n/100) {
        mylib_display_dec(data[i]);
        mylib_display_char(' ');
    }
    mylib_display_newline();
    
    mylib_finalize();
    return 0;
}
/**********************************************************************/
